-- Upgrade script for the field wie_gruppenangebot
-- Part of mpuls/issue7482

CREATE TABLE wie_gruppenangebot_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(31) NOT NULL
);

INSERT INTO wie_gruppenangebot_tbl (id, value) VALUES (-4, 'Keine Angabe weil Bestandsakte');
INSERT INTO wie_gruppenangebot_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO wie_gruppenangebot_tbl (id, value) VALUES (1, 'Online');
INSERT INTO wie_gruppenangebot_tbl (id, value) VALUES (2, 'Vor ort');
INSERT INTO wie_gruppenangebot_tbl (id, value) VALUES (3, 'Hybrid');

GRANT SELECT ON wie_gruppenangebot_tbl TO GROUP :cm_group;
GRANT SELECT ON wie_gruppenangebot_tbl TO GROUP :admin_group;


ALTER TABLE rg_gruppenangebote_tbl
  ADD COLUMN wie_gruppenangebot INTEGER DEFAULT -1
      REFERENCES wie_gruppenangebot_tbl (id);


-- update existing cases.
--
-- For completed cases, phase = "Erfassung beendet" = 1, and
-- rg_gruppenangebote_tbl rows where datum_ende_gruppenangebot is not
-- NULL and in the past, wie_gruppenangebot is set to -4.

UPDATE rg_gruppenangebote_tbl
   SET wie_gruppenangebot = -4
 WHERE datum_ende_gruppenangebot <= CURRENT_DATE
    OR EXISTS (SELECT * FROM master_tbl WHERE id = master_id AND phase = 1);

