BEGIN;

--
-- Add some new rg to the struktur prt rg_koop, change the structure of the 
-- formular here, needs convert. (Issue 3400)
--

-- Need to disable trigger
ALTER TABLE master_tbl DISABLE TRIGGER USER;
SET ROLE :db_adm;

-- History
INSERT INTO db_history (beschreibung, zeitpunkt)
VALUES ('1.1/06_rg_koop.sql', current_timestamp);

-- New option tables
-- Create new option tables
CREATE TABLE rg_koop_bewertungen_institution_art_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(77) NOT NULL
);
CREATE TABLE rg_koop_5_institution_art_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(76) NOT NULL
);
CREATE TABLE rg_koop_4_institution_art_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(63) NOT NULL
);
CREATE TABLE rg_koop_3_institution_art_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(35) NOT NULL
);
CREATE TABLE rg_koop_2_institution_art_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(71) NOT NULL
);
CREATE TABLE rg_koop_1_institution_art_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(77) NOT NULL
);

-- New option tables
-- fill these option tables
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (-3, 'Unbekannt');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (0, 'Jugendamt ');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (1, 'Einrichtungen der schulbezogenen Jugendsozialarbeit');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (2, 'Ausbildungszentren / Jugendwerkstätten');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (3, 'Einrichtungen für berufsvorbereitende Maßnahmen');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (4, 'Einrichtungen für berufsbegleitende Maßnahmen');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (5, 'Beratungsstellen der öffentlichen  Jugendhilfe');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (6, 'Einrichtungen der Heimerziehung');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (7, 'Jugendgerichtshilfe');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (8, 'Jugendzentren / offene Jugendarbeit');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (9, 'STÄRKEN vor Ort');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (10, 'Kompetenzagenturen');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (11, 'Koordinierungsstelle Schulverweigerung – Die 2. Chance');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (13, 'Sonstige');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (14, 'Jugendmigrationsdienste');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (15, 'Kommunale Migrationsdienste');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (16, 'Migrationsberatung (MBE)');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (17, 'anderweitig geförderte Erwachsenenmigrationsdienste');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (18, 'Übergangswohnheime / Gemeinschaftsunterkünfte / Aufnahmeeinrichtungen ');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (19, 'Interkulturelle Zentren / Vereine');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (20, 'Integrationskursträger');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (21, 'Integrations-, Aussiedler/innen-, Ausländer/innenbeautragte/r');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (22, 'Kommunale Referate für Integrationsfragen');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (23, 'Kompetenzzentrum für Integration (NRW)');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (24, 'Fördereinrichtungen für schulpflichtige Migrant/en/innen');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (25, 'Vereine von Migrant/en/innen');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (26, 'Länderspezifische Integrationsangebote');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (27, 'Sonstige');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (28, 'Allgemeinbildende Schulen');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (29, 'Weiterführende Schulen');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (30, 'Berufliche Schulen / Berufsschulen');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (31, 'Schulamt / Schulverwaltung');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (32, 'Schulsozialarbeit');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (33, 'Schulpsychologischer Dienst');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (34, 'Sonstige');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (35, 'Jobcenter');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (36, 'Ausländerbehörde');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (37, 'Ausgleichsamt / Vertriebenenamt');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (38, 'Sozialamt');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (39, 'Gesundheitsamt / Krankenhäuser / Ärzte');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (40, 'Stadtverwaltung / Gemeindeverwaltung / Bürgeramt / Meldestelle');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (41, 'Kreisverwaltung / Landratsamt / Regierungsbezirke');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (42, 'Polizei');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (43, 'Regionalkoordinator/en/innen des BAMF');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (44, 'Jugendstrafanstalt');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (45, 'Sonstige');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (46, 'Arbeitgeber/innen / Betriebe');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (47, 'Handwerks-/ Industrie- und Handelskammer');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (48, 'Bildungsträger für Aus- und Weiterbildung');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (49, 'Träger der politischen Bildung');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (50, 'Begegnungsstätten / Kulturzentren');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (51, 'Kirchengemeinden');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (52, 'Medien (Presse, Funk und Fernsehen)');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (53, 'Stiftungen');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (54, 'Selbsthilfevereine');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (55, 'Mehrgenerationenhäuser');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (56, 'Beratungsstellen (Schuldnerberatung, Drogenberatung, Bewährungshilfe, etc.)');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (57, 'Förderschulen');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (58, 'Flüchtlingsorganisationen');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (60, 'Koordinierungsstelle des Modellprogramms JUGEND STÄRKEN: Aktiv in der Region');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (62, 'Religions- und Glaubensgemeinschaften');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (63, 'Wirtschaftsjunioren (Projekt JUGEND STÄRKEN: Junge Wirtschaft macht mit!)');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (64, 'Sonstige');

INSERT INTO rg_koop_5_institution_art_tbl (id, value) VALUES (-3, 'Unbekannt');
INSERT INTO rg_koop_5_institution_art_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO rg_koop_5_institution_art_tbl (id, value) VALUES (46, 'Arbeitgeber/innen / Betriebe');
INSERT INTO rg_koop_5_institution_art_tbl (id, value) VALUES (47, 'Handwerks-/ Industrie- und Handelskammer');
INSERT INTO rg_koop_5_institution_art_tbl (id, value) VALUES (48, 'Bildungsträger für Aus- und Weiterbildung');
INSERT INTO rg_koop_5_institution_art_tbl (id, value) VALUES (49, 'Träger der politischen Bildung');
INSERT INTO rg_koop_5_institution_art_tbl (id, value) VALUES (50, 'Begegnungsstätten / Kulturzentren');
INSERT INTO rg_koop_5_institution_art_tbl (id, value) VALUES (51, 'Kirchengemeinden');
INSERT INTO rg_koop_5_institution_art_tbl (id, value) VALUES (52, 'Medien (Presse, Funk und Fernsehen)');
INSERT INTO rg_koop_5_institution_art_tbl (id, value) VALUES (53, 'Stiftungen');
INSERT INTO rg_koop_5_institution_art_tbl (id, value) VALUES (54, 'Selbsthilfevereine');
INSERT INTO rg_koop_5_institution_art_tbl (id, value) VALUES (55, 'Mehrgenerationenhäuser');
INSERT INTO rg_koop_5_institution_art_tbl (id, value) VALUES (56, 'Beratungsstellen (Schuldnerberatung, Drogenberatung, Bewährungshilfe, etc.)');
INSERT INTO rg_koop_5_institution_art_tbl (id, value) VALUES (62, 'Religions- und Glaubensgemeinschaften');
INSERT INTO rg_koop_5_institution_art_tbl (id, value) VALUES (63, 'Wirtschaftsjunioren (Projekt JUGEND STÄRKEN: Junge Wirtschaft macht mit!)');
INSERT INTO rg_koop_5_institution_art_tbl (id, value) VALUES (64, 'Sonstige');

INSERT INTO rg_koop_4_institution_art_tbl (id, value) VALUES (-3, 'Unbekannt');
INSERT INTO rg_koop_4_institution_art_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO rg_koop_4_institution_art_tbl (id, value) VALUES (35, 'Jobcenter');
INSERT INTO rg_koop_4_institution_art_tbl (id, value) VALUES (36, 'Ausländerbehörde');
INSERT INTO rg_koop_4_institution_art_tbl (id, value) VALUES (37, 'Ausgleichsamt / Vertriebenenamt');
INSERT INTO rg_koop_4_institution_art_tbl (id, value) VALUES (38, 'Sozialamt');
INSERT INTO rg_koop_4_institution_art_tbl (id, value) VALUES (39, 'Gesundheitsamt / Krankenhäuser / Ärzte');
INSERT INTO rg_koop_4_institution_art_tbl (id, value) VALUES (40, 'Stadtverwaltung / Gemeindeverwaltung / Bürgeramt / Meldestelle');
INSERT INTO rg_koop_4_institution_art_tbl (id, value) VALUES (41, 'Kreisverwaltung / Landratsamt / Regierungsbezirke');
INSERT INTO rg_koop_4_institution_art_tbl (id, value) VALUES (42, 'Polizei');
INSERT INTO rg_koop_4_institution_art_tbl (id, value) VALUES (44, 'Jugendstrafanstalt');
INSERT INTO rg_koop_4_institution_art_tbl (id, value) VALUES (45, 'Sonstige');

INSERT INTO rg_koop_3_institution_art_tbl (id, value) VALUES (-3, 'Unbekannt');
INSERT INTO rg_koop_3_institution_art_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO rg_koop_3_institution_art_tbl (id, value) VALUES (28, 'Allgemeinbildende Schulen');
INSERT INTO rg_koop_3_institution_art_tbl (id, value) VALUES (29, 'Weiterführende Schulen');
INSERT INTO rg_koop_3_institution_art_tbl (id, value) VALUES (30, 'Berufliche Schulen / Berufsschulen');
INSERT INTO rg_koop_3_institution_art_tbl (id, value) VALUES (31, 'Schulamt / Schulverwaltung');
INSERT INTO rg_koop_3_institution_art_tbl (id, value) VALUES (32, 'Schulsozialarbeit');
INSERT INTO rg_koop_3_institution_art_tbl (id, value) VALUES (33, 'Schulpsychologischer Dienst');
INSERT INTO rg_koop_3_institution_art_tbl (id, value) VALUES (34, 'Sonstige');
INSERT INTO rg_koop_3_institution_art_tbl (id, value) VALUES (57, 'Förderschulen');

INSERT INTO rg_koop_2_institution_art_tbl (id, value) VALUES (-3, 'Unbekannt');
INSERT INTO rg_koop_2_institution_art_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO rg_koop_2_institution_art_tbl (id, value) VALUES (14, 'Jugendmigrationsdienste');
INSERT INTO rg_koop_2_institution_art_tbl (id, value) VALUES (15, 'Kommunale Migrationsdienste');
INSERT INTO rg_koop_2_institution_art_tbl (id, value) VALUES (16, 'Migrationsberatung (MBE)');
INSERT INTO rg_koop_2_institution_art_tbl (id, value) VALUES (17, 'anderweitig geförderte Erwachsenenmigrationsdienste');
INSERT INTO rg_koop_2_institution_art_tbl (id, value) VALUES (18, 'Übergangswohnheime / Gemeinschaftsunterkünfte / Aufnahmeeinrichtungen ');
INSERT INTO rg_koop_2_institution_art_tbl (id, value) VALUES (19, 'Interkulturelle Zentren / Vereine');
INSERT INTO rg_koop_2_institution_art_tbl (id, value) VALUES (20, 'Integrationskursträger');
INSERT INTO rg_koop_2_institution_art_tbl (id, value) VALUES (21, 'Integrations-, Aussiedler/innen-, Ausländer/innenbeautragte/r');
INSERT INTO rg_koop_2_institution_art_tbl (id, value) VALUES (22, 'Kommunale Referate für Integrationsfragen');
INSERT INTO rg_koop_2_institution_art_tbl (id, value) VALUES (23, 'Kompetenzzentrum für Integration (NRW)');
INSERT INTO rg_koop_2_institution_art_tbl (id, value) VALUES (24, 'Fördereinrichtungen für schulpflichtige Migrant/en/innen');
INSERT INTO rg_koop_2_institution_art_tbl (id, value) VALUES (25, 'Vereine von Migrant/en/innen');
INSERT INTO rg_koop_2_institution_art_tbl (id, value) VALUES (26, 'Länderspezifische Integrationsangebote');
INSERT INTO rg_koop_2_institution_art_tbl (id, value) VALUES (27, 'Sonstige');
INSERT INTO rg_koop_2_institution_art_tbl (id, value) VALUES (43, 'Regionalkoordinator/en/innen des BAMF');
INSERT INTO rg_koop_2_institution_art_tbl (id, value) VALUES (58, 'Flüchtlingsorganisationen');

INSERT INTO rg_koop_1_institution_art_tbl (id, value) VALUES (-3, 'Unbekannt');
INSERT INTO rg_koop_1_institution_art_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO rg_koop_1_institution_art_tbl (id, value) VALUES (0, 'Jugendamt ');
INSERT INTO rg_koop_1_institution_art_tbl (id, value) VALUES (1, 'Einrichtungen der schulbezogenen Jugendsozialarbeit');
INSERT INTO rg_koop_1_institution_art_tbl (id, value) VALUES (2, 'Ausbildungszentren / Jugendwerkstätten');
INSERT INTO rg_koop_1_institution_art_tbl (id, value) VALUES (3, 'Einrichtungen für berufsvorbereitende Maßnahmen');
INSERT INTO rg_koop_1_institution_art_tbl (id, value) VALUES (4, 'Einrichtungen für berufsbegleitende Maßnahmen');
INSERT INTO rg_koop_1_institution_art_tbl (id, value) VALUES (5, 'Beratungsstellen der öffentlichen  Jugendhilfe');
INSERT INTO rg_koop_1_institution_art_tbl (id, value) VALUES (6, 'Einrichtungen der Heimerziehung');
INSERT INTO rg_koop_1_institution_art_tbl (id, value) VALUES (7, 'Jugendgerichtshilfe');
INSERT INTO rg_koop_1_institution_art_tbl (id, value) VALUES (8, 'Jugendzentren / offene Jugendarbeit');
INSERT INTO rg_koop_1_institution_art_tbl (id, value) VALUES (9, 'STÄRKEN vor Ort');
INSERT INTO rg_koop_1_institution_art_tbl (id, value) VALUES (10, 'Kompetenzagenturen');
INSERT INTO rg_koop_1_institution_art_tbl (id, value) VALUES (11, 'Koordinierungsstelle Schulverweigerung – Die 2. Chance');
INSERT INTO rg_koop_1_institution_art_tbl (id, value) VALUES (13, 'Sonstige');
INSERT INTO rg_koop_1_institution_art_tbl (id, value) VALUES (60, 'Koordinierungsstelle des Modellprogramms JUGEND STÄRKEN: Aktiv in der Region');

-- New option tables
-- grant rights
GRANT SELECT ON rg_koop_bewertungen_institution_art_tbl TO GROUP :cm_group;
GRANT SELECT ON rg_koop_bewertungen_institution_art_tbl TO GROUP :admin_group;
GRANT SELECT ON rg_koop_5_institution_art_tbl TO GROUP :cm_group;
GRANT SELECT ON rg_koop_5_institution_art_tbl TO GROUP :admin_group;
GRANT SELECT ON rg_koop_4_institution_art_tbl TO GROUP :cm_group;
GRANT SELECT ON rg_koop_4_institution_art_tbl TO GROUP :admin_group;
GRANT SELECT ON rg_koop_3_institution_art_tbl TO GROUP :cm_group;
GRANT SELECT ON rg_koop_3_institution_art_tbl TO GROUP :admin_group;
GRANT SELECT ON rg_koop_2_institution_art_tbl TO GROUP :cm_group;
GRANT SELECT ON rg_koop_2_institution_art_tbl TO GROUP :admin_group;
GRANT SELECT ON rg_koop_1_institution_art_tbl TO GROUP :cm_group;
GRANT SELECT ON rg_koop_1_institution_art_tbl TO GROUP :admin_group;

-- New repeat group tables
-- creation
CREATE TABLE rg_koop_1_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    master_id INTEGER NOT NULL,
    uuid_id CHAR(36),
    rg_koop_1_institution_art INTEGER DEFAULT -1,
    rg_koop_1_anzahl INTEGER,
    rg_koop_1_partner INTEGER,
    rg_koop_1_schriftlich INTEGER,
    FOREIGN KEY (master_id) REFERENCES master_tbl (id) ON DELETE CASCADE,
    UNIQUE (uuid_id),
    FOREIGN KEY (rg_koop_1_institution_art) REFERENCES rg_koop_1_institution_art_tbl (id)
);
CREATE TABLE rg_koop_2_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    master_id INTEGER NOT NULL,
    uuid_id CHAR(36),
    rg_koop_2_institution_art INTEGER DEFAULT -1,
    rg_koop_2_anzahl INTEGER,
    rg_koop_2_partner INTEGER,
    rg_koop_2_schriftlich INTEGER,
    FOREIGN KEY (master_id) REFERENCES master_tbl (id) ON DELETE CASCADE,
    UNIQUE (uuid_id),
    FOREIGN KEY (rg_koop_2_institution_art) REFERENCES rg_koop_2_institution_art_tbl (id)
);
CREATE TABLE rg_koop_3_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    master_id INTEGER NOT NULL,
    uuid_id CHAR(36),
    rg_koop_3_institution_art INTEGER DEFAULT -1,
    rg_koop_3_anzahl INTEGER,
    rg_koop_3_partner INTEGER,
    rg_koop_3_schriftlich INTEGER,
    FOREIGN KEY (master_id) REFERENCES master_tbl (id) ON DELETE CASCADE,
    UNIQUE (uuid_id),
    FOREIGN KEY (rg_koop_3_institution_art) REFERENCES rg_koop_3_institution_art_tbl (id)
);
CREATE TABLE rg_koop_4_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    master_id INTEGER NOT NULL,
    uuid_id CHAR(36),
    rg_koop_4_institution_art INTEGER DEFAULT -1,
    rg_koop_4_anzahl INTEGER,
    rg_koop_4_partner INTEGER,
    rg_koop_4_schriftlich INTEGER,
    FOREIGN KEY (master_id) REFERENCES master_tbl (id) ON DELETE CASCADE,
    UNIQUE (uuid_id),
    FOREIGN KEY (rg_koop_4_institution_art) REFERENCES rg_koop_4_institution_art_tbl (id)
);
CREATE TABLE rg_koop_5_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    master_id INTEGER NOT NULL,
    uuid_id CHAR(36),
    rg_koop_5_institution_art INTEGER DEFAULT -1,
    rg_koop_5_anzahl INTEGER,
    rg_koop_5_partner INTEGER,
    rg_koop_5_schriftlich INTEGER,
    FOREIGN KEY (master_id) REFERENCES master_tbl (id) ON DELETE CASCADE,
    UNIQUE (uuid_id),
    FOREIGN KEY (rg_koop_5_institution_art) REFERENCES rg_koop_5_institution_art_tbl (id)
);
CREATE TABLE rg_koop_bewertungen_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    master_id INTEGER NOT NULL,
    uuid_id CHAR(36),
    rg_koop_bewertungen_institution_art INTEGER DEFAULT -1,
    institution_unterstuetzt_aktiv INTEGER DEFAULT -1,
    jmd_erreicht_andere_durchfuehrung INTEGER DEFAULT -1,
    jmd_hat_einfluss_teilnehmer INTEGER DEFAULT -1,
    institution_legt_infomaterial INTEGER DEFAULT -1,
    institution_zufuehrung_menschen INTEGER DEFAULT -1,
    besteht_informationsaustausch INTEGER DEFAULT -1,
    besteht_regelmaessiger_austausch_fallbezogen INTEGER DEFAULT -1,
    besteht_regelmaessiger_austausch_nichtfallbezogen INTEGER DEFAULT -1,
    besteht_abstimmung_integrationsfp INTEGER DEFAULT -1,
    besteht_planung_veranstaltung INTEGER DEFAULT -1,
    besteht_gemeinsame_oeffentlichkeitsarbeit INTEGER DEFAULT -1,
    kontakt_besteht_ueber_gremien INTEGER DEFAULT -1,
    jmd_nimmt_an_verstaltungen_teil INTEGER DEFAULT -1,
    jmd_fuehrt_beratung_durch INTEGER DEFAULT -1,
    kooperation_schriftlich_festgelegt INTEGER DEFAULT -1,
    jmd_als_partner_auf_augenhoehe INTEGER DEFAULT -1,
    kontaktform INTEGER DEFAULT -1,
    gesamtbewertung INTEGER DEFAULT -1,
    nennung_besonderheiten_zusammenarbeit TEXT,
    nennung_erfahrungen_zusammenarbeit TEXT,
    FOREIGN KEY (master_id) REFERENCES master_tbl (id) ON DELETE CASCADE,
    UNIQUE (uuid_id),
    FOREIGN KEY (rg_koop_bewertungen_institution_art) REFERENCES rg_koop_bewertungen_institution_art_tbl (id),
    FOREIGN KEY (institution_unterstuetzt_aktiv) REFERENCES traeger_integrationskurs_tbl (id),
    FOREIGN KEY (jmd_erreicht_andere_durchfuehrung) REFERENCES jmd_erreicht_andere_durchfuehrung_tbl (id),
    FOREIGN KEY (jmd_hat_einfluss_teilnehmer) REFERENCES jmd_erreicht_andere_durchfuehrung_tbl (id),
    FOREIGN KEY (institution_legt_infomaterial) REFERENCES jmd_erreicht_andere_durchfuehrung_tbl (id),
    FOREIGN KEY (institution_zufuehrung_menschen) REFERENCES jmd_erreicht_andere_durchfuehrung_tbl (id),
    FOREIGN KEY (besteht_informationsaustausch) REFERENCES traeger_integrationskurs_tbl (id),
    FOREIGN KEY (besteht_regelmaessiger_austausch_fallbezogen) REFERENCES jmd_erreicht_andere_durchfuehrung_tbl (id),
    FOREIGN KEY (besteht_regelmaessiger_austausch_nichtfallbezogen) REFERENCES jmd_erreicht_andere_durchfuehrung_tbl (id),
    FOREIGN KEY (besteht_abstimmung_integrationsfp) REFERENCES jmd_erreicht_andere_durchfuehrung_tbl (id),
    FOREIGN KEY (besteht_planung_veranstaltung) REFERENCES jmd_erreicht_andere_durchfuehrung_tbl (id),
    FOREIGN KEY (besteht_gemeinsame_oeffentlichkeitsarbeit) REFERENCES jmd_erreicht_andere_durchfuehrung_tbl (id),
    FOREIGN KEY (kontakt_besteht_ueber_gremien) REFERENCES traeger_integrationskurs_tbl (id),
    FOREIGN KEY (jmd_nimmt_an_verstaltungen_teil) REFERENCES jmd_nimmt_an_verstaltungen_teil_tbl (id),
    FOREIGN KEY (jmd_fuehrt_beratung_durch) REFERENCES jmd_nimmt_an_verstaltungen_teil_tbl (id),
    FOREIGN KEY (kooperation_schriftlich_festgelegt) REFERENCES jmd_nimmt_an_verstaltungen_teil_tbl (id),
    FOREIGN KEY (jmd_als_partner_auf_augenhoehe) REFERENCES jmd_erreicht_andere_durchfuehrung_tbl (id),
    FOREIGN KEY (kontaktform) REFERENCES kontaktform_tbl (id),
    FOREIGN KEY (gesamtbewertung) REFERENCES gesamtbewertung_tbl (id)
);

-- New repeat group tables
-- Add Views (rg_view and rg_anonym) and rules
CREATE OR REPLACE VIEW rg_koop_1_tbl_view
AS SELECT 
     rg_koop_1_tbl.id AS id,
     rg_koop_1_tbl.master_id AS master_id,
     rg_koop_1_tbl.uuid_id AS uuid_id,
     rg_koop_1_tbl.rg_koop_1_institution_art AS rg_koop_1_institution_art,
     rg_koop_1_tbl.rg_koop_1_anzahl AS rg_koop_1_anzahl,
     rg_koop_1_tbl.rg_koop_1_partner AS rg_koop_1_partner,
     rg_koop_1_tbl.rg_koop_1_schriftlich AS rg_koop_1_schriftlich
FROM rg_koop_1_tbl
    INNER JOIN master_tbl
    ON         rg_koop_1_tbl.master_id = master_tbl.id
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
        WHERE nm.benutzer_id IN (
            SELECT nm2.gruppe_id from nm_benutzer_gruppe_tbl nm2
            WHERE nm2.benutzer_id = getuserid()
        )
    )
    OR pg_has_role('admin','MEMBER');

CREATE OR REPLACE RULE rg_koop_1_tbl_update_rule AS ON UPDATE TO rg_koop_1_tbl_view
DO INSTEAD UPDATE rg_koop_1_tbl SET
    rg_koop_1_institution_art = NEW.rg_koop_1_institution_art,
    rg_koop_1_anzahl = NEW.rg_koop_1_anzahl,
    rg_koop_1_partner = NEW.rg_koop_1_partner,
    rg_koop_1_schriftlich = NEW.rg_koop_1_schriftlich
WHERE id = NEW.id;

CREATE OR REPLACE RULE rg_koop_1_tbl_delete_rule AS ON DELETE TO rg_koop_1_tbl_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_koop_1_tbl_insert_rule AS ON INSERT TO rg_koop_1_tbl_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_koop_1_tbl_view TO GROUP :cm_group;
GRANT UPDATE ON rg_koop_1_tbl_view TO GROUP :cm_group;
GRANT SELECT ON rg_koop_1_tbl_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW rg_koop_1_tbl_anonym_view
AS SELECT
    id,
    master_id,
    uuid_id,
    rg_koop_1_institution_art,
    rg_koop_1_anzahl,
    rg_koop_1_partner,
    rg_koop_1_schriftlich FROM rg_koop_1_tbl_view;

CREATE OR REPLACE RULE rg_koop_1_tbl_anonym_delete_rule AS ON DELETE TO rg_koop_1_tbl_anonym_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_koop_1_tbl_anonym_insert_rule AS ON INSERT TO rg_koop_1_tbl_anonym_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_koop_1_tbl_anonym_view TO GROUP :cm_group;
GRANT SELECT ON rg_koop_1_tbl_anonym_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW rg_koop_2_tbl_view
AS SELECT 
     rg_koop_2_tbl.id AS id,
     rg_koop_2_tbl.master_id AS master_id,
     rg_koop_2_tbl.uuid_id AS uuid_id,
     rg_koop_2_tbl.rg_koop_2_institution_art AS rg_koop_2_institution_art,
     rg_koop_2_tbl.rg_koop_2_anzahl AS rg_koop_2_anzahl,
     rg_koop_2_tbl.rg_koop_2_partner AS rg_koop_2_partner,
     rg_koop_2_tbl.rg_koop_2_schriftlich AS rg_koop_2_schriftlich
FROM rg_koop_2_tbl
    INNER JOIN master_tbl
    ON         rg_koop_2_tbl.master_id = master_tbl.id
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
        WHERE nm.benutzer_id IN (
            SELECT nm2.gruppe_id from nm_benutzer_gruppe_tbl nm2
            WHERE nm2.benutzer_id = getuserid()
        )
    )
    OR pg_has_role('admin','MEMBER');

CREATE OR REPLACE RULE rg_koop_2_tbl_update_rule AS ON UPDATE TO rg_koop_2_tbl_view
DO INSTEAD UPDATE rg_koop_2_tbl SET
    rg_koop_2_institution_art = NEW.rg_koop_2_institution_art,
    rg_koop_2_anzahl = NEW.rg_koop_2_anzahl,
    rg_koop_2_partner = NEW.rg_koop_2_partner,
    rg_koop_2_schriftlich = NEW.rg_koop_2_schriftlich
WHERE id = NEW.id;

CREATE OR REPLACE RULE rg_koop_2_tbl_delete_rule AS ON DELETE TO rg_koop_2_tbl_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_koop_2_tbl_insert_rule AS ON INSERT TO rg_koop_2_tbl_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_koop_2_tbl_view TO GROUP :cm_group;
GRANT UPDATE ON rg_koop_2_tbl_view TO GROUP :cm_group;
GRANT SELECT ON rg_koop_2_tbl_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW rg_koop_2_tbl_anonym_view
AS SELECT
    id,
    master_id,
    uuid_id,
    rg_koop_2_institution_art,
    rg_koop_2_anzahl,
    rg_koop_2_partner,
    rg_koop_2_schriftlich FROM rg_koop_2_tbl_view;

CREATE OR REPLACE RULE rg_koop_2_tbl_anonym_delete_rule AS ON DELETE TO rg_koop_2_tbl_anonym_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_koop_2_tbl_anonym_insert_rule AS ON INSERT TO rg_koop_2_tbl_anonym_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_koop_2_tbl_anonym_view TO GROUP :cm_group;
GRANT SELECT ON rg_koop_2_tbl_anonym_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW rg_koop_3_tbl_view
AS SELECT 
     rg_koop_3_tbl.id AS id,
     rg_koop_3_tbl.master_id AS master_id,
     rg_koop_3_tbl.uuid_id AS uuid_id,
     rg_koop_3_tbl.rg_koop_3_institution_art AS rg_koop_3_institution_art,
     rg_koop_3_tbl.rg_koop_3_anzahl AS rg_koop_3_anzahl,
     rg_koop_3_tbl.rg_koop_3_partner AS rg_koop_3_partner,
     rg_koop_3_tbl.rg_koop_3_schriftlich AS rg_koop_3_schriftlich
FROM rg_koop_3_tbl
    INNER JOIN master_tbl
    ON         rg_koop_3_tbl.master_id = master_tbl.id
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
        WHERE nm.benutzer_id IN (
            SELECT nm2.gruppe_id from nm_benutzer_gruppe_tbl nm2
            WHERE nm2.benutzer_id = getuserid()
        )
    )
    OR pg_has_role('admin','MEMBER');

CREATE OR REPLACE RULE rg_koop_3_tbl_update_rule AS ON UPDATE TO rg_koop_3_tbl_view
DO INSTEAD UPDATE rg_koop_3_tbl SET
    rg_koop_3_institution_art = NEW.rg_koop_3_institution_art,
    rg_koop_3_anzahl = NEW.rg_koop_3_anzahl,
    rg_koop_3_partner = NEW.rg_koop_3_partner,
    rg_koop_3_schriftlich = NEW.rg_koop_3_schriftlich
WHERE id = NEW.id;

CREATE OR REPLACE RULE rg_koop_3_tbl_delete_rule AS ON DELETE TO rg_koop_3_tbl_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_koop_3_tbl_insert_rule AS ON INSERT TO rg_koop_3_tbl_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_koop_3_tbl_view TO GROUP :cm_group;
GRANT UPDATE ON rg_koop_3_tbl_view TO GROUP :cm_group;
GRANT SELECT ON rg_koop_3_tbl_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW rg_koop_3_tbl_anonym_view
AS SELECT
    id,
    master_id,
    uuid_id,
    rg_koop_3_institution_art,
    rg_koop_3_anzahl,
    rg_koop_3_partner,
    rg_koop_3_schriftlich FROM rg_koop_3_tbl_view;

CREATE OR REPLACE RULE rg_koop_3_tbl_anonym_delete_rule AS ON DELETE TO rg_koop_3_tbl_anonym_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_koop_3_tbl_anonym_insert_rule AS ON INSERT TO rg_koop_3_tbl_anonym_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_koop_3_tbl_anonym_view TO GROUP :cm_group;
GRANT SELECT ON rg_koop_3_tbl_anonym_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW rg_koop_4_tbl_view
AS SELECT 
     rg_koop_4_tbl.id AS id,
     rg_koop_4_tbl.master_id AS master_id,
     rg_koop_4_tbl.uuid_id AS uuid_id,
     rg_koop_4_tbl.rg_koop_4_institution_art AS rg_koop_4_institution_art,
     rg_koop_4_tbl.rg_koop_4_anzahl AS rg_koop_4_anzahl,
     rg_koop_4_tbl.rg_koop_4_partner AS rg_koop_4_partner,
     rg_koop_4_tbl.rg_koop_4_schriftlich AS rg_koop_4_schriftlich
FROM rg_koop_4_tbl
    INNER JOIN master_tbl
    ON         rg_koop_4_tbl.master_id = master_tbl.id
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
        WHERE nm.benutzer_id IN (
            SELECT nm2.gruppe_id from nm_benutzer_gruppe_tbl nm2
            WHERE nm2.benutzer_id = getuserid()
        )
    )
    OR pg_has_role('admin','MEMBER');

CREATE OR REPLACE RULE rg_koop_4_tbl_update_rule AS ON UPDATE TO rg_koop_4_tbl_view
DO INSTEAD UPDATE rg_koop_4_tbl SET
    rg_koop_4_institution_art = NEW.rg_koop_4_institution_art,
    rg_koop_4_anzahl = NEW.rg_koop_4_anzahl,
    rg_koop_4_partner = NEW.rg_koop_4_partner,
    rg_koop_4_schriftlich = NEW.rg_koop_4_schriftlich
WHERE id = NEW.id;

CREATE OR REPLACE RULE rg_koop_4_tbl_delete_rule AS ON DELETE TO rg_koop_4_tbl_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_koop_4_tbl_insert_rule AS ON INSERT TO rg_koop_4_tbl_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_koop_4_tbl_view TO GROUP :cm_group;
GRANT UPDATE ON rg_koop_4_tbl_view TO GROUP :cm_group;
GRANT SELECT ON rg_koop_4_tbl_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW rg_koop_4_tbl_anonym_view
AS SELECT
    id,
    master_id,
    uuid_id,
    rg_koop_4_institution_art,
    rg_koop_4_anzahl,
    rg_koop_4_partner,
    rg_koop_4_schriftlich FROM rg_koop_4_tbl_view;

CREATE OR REPLACE RULE rg_koop_4_tbl_anonym_delete_rule AS ON DELETE TO rg_koop_4_tbl_anonym_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_koop_4_tbl_anonym_insert_rule AS ON INSERT TO rg_koop_4_tbl_anonym_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_koop_4_tbl_anonym_view TO GROUP :cm_group;
GRANT SELECT ON rg_koop_4_tbl_anonym_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW rg_koop_5_tbl_view
AS SELECT 
     rg_koop_5_tbl.id AS id,
     rg_koop_5_tbl.master_id AS master_id,
     rg_koop_5_tbl.uuid_id AS uuid_id,
     rg_koop_5_tbl.rg_koop_5_institution_art AS rg_koop_5_institution_art,
     rg_koop_5_tbl.rg_koop_5_anzahl AS rg_koop_5_anzahl,
     rg_koop_5_tbl.rg_koop_5_partner AS rg_koop_5_partner,
     rg_koop_5_tbl.rg_koop_5_schriftlich AS rg_koop_5_schriftlich
FROM rg_koop_5_tbl
    INNER JOIN master_tbl
    ON         rg_koop_5_tbl.master_id = master_tbl.id
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
        WHERE nm.benutzer_id IN (
            SELECT nm2.gruppe_id from nm_benutzer_gruppe_tbl nm2
            WHERE nm2.benutzer_id = getuserid()
        )
    )
    OR pg_has_role('admin','MEMBER');

CREATE OR REPLACE RULE rg_koop_5_tbl_update_rule AS ON UPDATE TO rg_koop_5_tbl_view
DO INSTEAD UPDATE rg_koop_5_tbl SET
    rg_koop_5_institution_art = NEW.rg_koop_5_institution_art,
    rg_koop_5_anzahl = NEW.rg_koop_5_anzahl,
    rg_koop_5_partner = NEW.rg_koop_5_partner,
    rg_koop_5_schriftlich = NEW.rg_koop_5_schriftlich
WHERE id = NEW.id;

CREATE OR REPLACE RULE rg_koop_5_tbl_delete_rule AS ON DELETE TO rg_koop_5_tbl_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_koop_5_tbl_insert_rule AS ON INSERT TO rg_koop_5_tbl_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_koop_5_tbl_view TO GROUP :cm_group;
GRANT UPDATE ON rg_koop_5_tbl_view TO GROUP :cm_group;
GRANT SELECT ON rg_koop_5_tbl_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW rg_koop_5_tbl_anonym_view
AS SELECT
    id,
    master_id,
    uuid_id,
    rg_koop_5_institution_art,
    rg_koop_5_anzahl,
    rg_koop_5_partner,
    rg_koop_5_schriftlich FROM rg_koop_5_tbl_view;

CREATE OR REPLACE RULE rg_koop_5_tbl_anonym_delete_rule AS ON DELETE TO rg_koop_5_tbl_anonym_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_koop_5_tbl_anonym_insert_rule AS ON INSERT TO rg_koop_5_tbl_anonym_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_koop_5_tbl_anonym_view TO GROUP :cm_group;
GRANT SELECT ON rg_koop_5_tbl_anonym_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW rg_koop_bewertungen_tbl_view
AS SELECT 
     rg_koop_bewertungen_tbl.id AS id,
     rg_koop_bewertungen_tbl.master_id AS master_id,
     rg_koop_bewertungen_tbl.uuid_id AS uuid_id,
     rg_koop_bewertungen_tbl.rg_koop_bewertungen_institution_art AS rg_koop_bewertungen_institution_art,
     rg_koop_bewertungen_tbl.institution_unterstuetzt_aktiv AS institution_unterstuetzt_aktiv,
     rg_koop_bewertungen_tbl.jmd_erreicht_andere_durchfuehrung AS jmd_erreicht_andere_durchfuehrung,
     rg_koop_bewertungen_tbl.jmd_hat_einfluss_teilnehmer AS jmd_hat_einfluss_teilnehmer,
     rg_koop_bewertungen_tbl.institution_legt_infomaterial AS institution_legt_infomaterial,
     rg_koop_bewertungen_tbl.institution_zufuehrung_menschen AS institution_zufuehrung_menschen,
     rg_koop_bewertungen_tbl.besteht_informationsaustausch AS besteht_informationsaustausch,
     rg_koop_bewertungen_tbl.besteht_regelmaessiger_austausch_fallbezogen AS besteht_regelmaessiger_austausch_fallbezogen,
     rg_koop_bewertungen_tbl.besteht_regelmaessiger_austausch_nichtfallbezogen AS besteht_regelmaessiger_austausch_nichtfallbezogen,
     rg_koop_bewertungen_tbl.besteht_abstimmung_integrationsfp AS besteht_abstimmung_integrationsfp,
     rg_koop_bewertungen_tbl.besteht_planung_veranstaltung AS besteht_planung_veranstaltung,
     rg_koop_bewertungen_tbl.besteht_gemeinsame_oeffentlichkeitsarbeit AS besteht_gemeinsame_oeffentlichkeitsarbeit,
     rg_koop_bewertungen_tbl.kontakt_besteht_ueber_gremien AS kontakt_besteht_ueber_gremien,
     rg_koop_bewertungen_tbl.jmd_nimmt_an_verstaltungen_teil AS jmd_nimmt_an_verstaltungen_teil,
     rg_koop_bewertungen_tbl.jmd_fuehrt_beratung_durch AS jmd_fuehrt_beratung_durch,
     rg_koop_bewertungen_tbl.kooperation_schriftlich_festgelegt AS kooperation_schriftlich_festgelegt,
     rg_koop_bewertungen_tbl.jmd_als_partner_auf_augenhoehe AS jmd_als_partner_auf_augenhoehe,
     rg_koop_bewertungen_tbl.kontaktform AS kontaktform,
     rg_koop_bewertungen_tbl.gesamtbewertung AS gesamtbewertung,
     rg_koop_bewertungen_tbl.nennung_besonderheiten_zusammenarbeit AS nennung_besonderheiten_zusammenarbeit,
     rg_koop_bewertungen_tbl.nennung_erfahrungen_zusammenarbeit AS nennung_erfahrungen_zusammenarbeit
FROM rg_koop_bewertungen_tbl
    INNER JOIN master_tbl
    ON         rg_koop_bewertungen_tbl.master_id = master_tbl.id
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
        WHERE nm.benutzer_id IN (
            SELECT nm2.gruppe_id from nm_benutzer_gruppe_tbl nm2
            WHERE nm2.benutzer_id = getuserid()
        )
    )
    OR pg_has_role('admin','MEMBER');

CREATE OR REPLACE RULE rg_koop_bewertungen_tbl_update_rule AS ON UPDATE TO rg_koop_bewertungen_tbl_view
DO INSTEAD UPDATE rg_koop_bewertungen_tbl SET
    rg_koop_bewertungen_institution_art = NEW.rg_koop_bewertungen_institution_art,
    institution_unterstuetzt_aktiv = NEW.institution_unterstuetzt_aktiv,
    jmd_erreicht_andere_durchfuehrung = NEW.jmd_erreicht_andere_durchfuehrung,
    jmd_hat_einfluss_teilnehmer = NEW.jmd_hat_einfluss_teilnehmer,
    institution_legt_infomaterial = NEW.institution_legt_infomaterial,
    institution_zufuehrung_menschen = NEW.institution_zufuehrung_menschen,
    besteht_informationsaustausch = NEW.besteht_informationsaustausch,
    besteht_regelmaessiger_austausch_fallbezogen = NEW.besteht_regelmaessiger_austausch_fallbezogen,
    besteht_regelmaessiger_austausch_nichtfallbezogen = NEW.besteht_regelmaessiger_austausch_nichtfallbezogen,
    besteht_abstimmung_integrationsfp = NEW.besteht_abstimmung_integrationsfp,
    besteht_planung_veranstaltung = NEW.besteht_planung_veranstaltung,
    besteht_gemeinsame_oeffentlichkeitsarbeit = NEW.besteht_gemeinsame_oeffentlichkeitsarbeit,
    kontakt_besteht_ueber_gremien = NEW.kontakt_besteht_ueber_gremien,
    jmd_nimmt_an_verstaltungen_teil = NEW.jmd_nimmt_an_verstaltungen_teil,
    jmd_fuehrt_beratung_durch = NEW.jmd_fuehrt_beratung_durch,
    kooperation_schriftlich_festgelegt = NEW.kooperation_schriftlich_festgelegt,
    jmd_als_partner_auf_augenhoehe = NEW.jmd_als_partner_auf_augenhoehe,
    kontaktform = NEW.kontaktform,
    gesamtbewertung = NEW.gesamtbewertung,
    nennung_besonderheiten_zusammenarbeit = NEW.nennung_besonderheiten_zusammenarbeit,
    nennung_erfahrungen_zusammenarbeit = NEW.nennung_erfahrungen_zusammenarbeit
WHERE id = NEW.id;

CREATE OR REPLACE RULE rg_koop_bewertungen_tbl_delete_rule AS ON DELETE TO rg_koop_bewertungen_tbl_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_koop_bewertungen_tbl_insert_rule AS ON INSERT TO rg_koop_bewertungen_tbl_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_koop_bewertungen_tbl_view TO GROUP :cm_group;
GRANT UPDATE ON rg_koop_bewertungen_tbl_view TO GROUP :cm_group;
GRANT SELECT ON rg_koop_bewertungen_tbl_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW rg_koop_bewertungen_tbl_anonym_view
AS SELECT
    id,
    master_id,
    uuid_id,
    rg_koop_bewertungen_institution_art,
    institution_unterstuetzt_aktiv,
    jmd_erreicht_andere_durchfuehrung,
    jmd_hat_einfluss_teilnehmer,
    institution_legt_infomaterial,
    institution_zufuehrung_menschen,
    besteht_informationsaustausch,
    besteht_regelmaessiger_austausch_fallbezogen,
    besteht_regelmaessiger_austausch_nichtfallbezogen,
    besteht_abstimmung_integrationsfp,
    besteht_planung_veranstaltung,
    besteht_gemeinsame_oeffentlichkeitsarbeit,
    kontakt_besteht_ueber_gremien,
    jmd_nimmt_an_verstaltungen_teil,
    jmd_fuehrt_beratung_durch,
    kooperation_schriftlich_festgelegt,
    jmd_als_partner_auf_augenhoehe,
    kontaktform,
    gesamtbewertung,
    nennung_besonderheiten_zusammenarbeit,
    nennung_erfahrungen_zusammenarbeit FROM rg_koop_bewertungen_tbl_view;

CREATE OR REPLACE RULE rg_koop_bewertungen_tbl_anonym_delete_rule AS ON DELETE TO rg_koop_bewertungen_tbl_anonym_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_koop_bewertungen_tbl_anonym_insert_rule AS ON INSERT TO rg_koop_bewertungen_tbl_anonym_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_koop_bewertungen_tbl_anonym_view TO GROUP :cm_group;
GRANT SELECT ON rg_koop_bewertungen_tbl_anonym_view TO GROUP :admin_group;

-- rgroups changes
-- PLPython is an untrusted language. -> Need to be postgres.
SET ROLE postgres;


-- update the compute_case_structure function as postgres
DROP FUNCTION compute_case_structure(int4);
CREATE OR REPLACE FUNCTION compute_case_structure(case_id int4) RETURNS TEXT
AS $$

class Node(object):

    def __init__(self, name, id=None, children=[]):
        self.name = name
        self.id = id
        self.children = children

    def to_json(self, out):
        out.append('{"name":"%s","id":%d' % (self.name, self.id))
        if self.children:
            out.append(',"children":[')
            first = True
            for child in self.children:
                if first:
                    first = False
                else:
                    out.append(",")
                child.to_json(out)
            out.append("]")
        out.append("}")

    def recursive_build(self, mid, children, parent_name="master"):
        select = ("SELECT id FROM %s WHERE %s_id = %d"
                  % (self.name, parent_name, mid))
        ids = [r['id'] for r in plpy.execute(select)]
        for id in ids:
            sub_children = []
            node = Node(self.name, id, sub_children)
            name = self.name[:-4] # cut off trailing '_tbl'
            for child in self.children:
                child.recursive_build(id, sub_children, name)
            children.append(node)

TREE_STRUCTURE = Node('master_tbl', children = [
    Node('rg_netzwerk_tbl'),
    Node('rg_koop_1_tbl'),
    Node('rg_koop_2_tbl'),
    Node('rg_koop_3_tbl'),
    Node('rg_koop_4_tbl'),
    Node('rg_koop_5_tbl'),
    Node('rg_koop_bewertungen_tbl'),
    Node('rg_kjp_gruppenangebote_tbl'),
    Node('rg_nichtkjp_gruppenangebote_tbl')
])


children = []
tree = Node(TREE_STRUCTURE.name, case_id, children)
for child in TREE_STRUCTURE.children:
    child.recursive_build(case_id, children)
out = []
tree.to_json(out)
return "".join(out)

$$ LANGUAGE plpythonu EXTERNAL SECURITY DEFINER;
ALTER FUNCTION compute_case_structure(int4) OWNER TO :adm_ka_owner;

-- Continue as db-owner from here
SET ROLE :adm_ka_owner;

-- rgroup changes
-- Set rg rules and trigger

CREATE OR REPLACE FUNCTION rg_koop_1_tbl_insert_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_koop_1_tbl_insert_trigger AFTER INSERT ON rg_koop_1_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_koop_1_tbl_insert_func();

CREATE OR REPLACE FUNCTION rg_koop_1_tbl_update_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql EXTERNAL SECURITY DEFINER;

CREATE TRIGGER rg_koop_1_tbl_update_trigger AFTER UPDATE ON rg_koop_1_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_koop_1_tbl_update_func();

CREATE OR REPLACE FUNCTION rg_koop_1_tbl_delete_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid OLD.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN OLD;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_koop_1_tbl_delete_trigger AFTER DELETE ON rg_koop_1_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_koop_1_tbl_delete_func();

-- DROP TRIGGER rg_koop_2_tbl_insert_trigger ON rg_koop_2_tbl CASCADE;
-- DROP FUNCTION rg_koop_2_tbl_insert_func();
-- DROP TRIGGER rg_koop_2_tbl_delete_trigger ON rg_koop_2_tbl CASCADE;
-- DROP FUNCTION rg_koop_2_tbl_delete_func();

CREATE OR REPLACE FUNCTION rg_koop_2_tbl_insert_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_koop_2_tbl_insert_trigger AFTER INSERT ON rg_koop_2_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_koop_2_tbl_insert_func();

CREATE OR REPLACE FUNCTION rg_koop_2_tbl_update_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql EXTERNAL SECURITY DEFINER;

CREATE TRIGGER rg_koop_2_tbl_update_trigger AFTER UPDATE ON rg_koop_2_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_koop_2_tbl_update_func();

CREATE OR REPLACE FUNCTION rg_koop_2_tbl_delete_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid OLD.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN OLD;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_koop_2_tbl_delete_trigger AFTER DELETE ON rg_koop_2_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_koop_2_tbl_delete_func();

-- DROP TRIGGER rg_koop_3_tbl_insert_trigger ON rg_koop_3_tbl CASCADE;
-- DROP FUNCTION rg_koop_3_tbl_insert_func();
-- DROP TRIGGER rg_koop_3_tbl_delete_trigger ON rg_koop_3_tbl CASCADE;
-- DROP FUNCTION rg_koop_3_tbl_delete_func();

CREATE OR REPLACE FUNCTION rg_koop_3_tbl_insert_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_koop_3_tbl_insert_trigger AFTER INSERT ON rg_koop_3_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_koop_3_tbl_insert_func();

CREATE OR REPLACE FUNCTION rg_koop_3_tbl_update_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql EXTERNAL SECURITY DEFINER;

CREATE TRIGGER rg_koop_3_tbl_update_trigger AFTER UPDATE ON rg_koop_3_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_koop_3_tbl_update_func();

CREATE OR REPLACE FUNCTION rg_koop_3_tbl_delete_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid OLD.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN OLD;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_koop_3_tbl_delete_trigger AFTER DELETE ON rg_koop_3_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_koop_3_tbl_delete_func();

-- DROP TRIGGER rg_koop_4_tbl_insert_trigger ON rg_koop_4_tbl CASCADE;
-- DROP FUNCTION rg_koop_4_tbl_insert_func();
-- DROP TRIGGER rg_koop_4_tbl_delete_trigger ON rg_koop_4_tbl CASCADE;
-- DROP FUNCTION rg_koop_4_tbl_delete_func();

CREATE OR REPLACE FUNCTION rg_koop_4_tbl_insert_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_koop_4_tbl_insert_trigger AFTER INSERT ON rg_koop_4_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_koop_4_tbl_insert_func();

CREATE OR REPLACE FUNCTION rg_koop_4_tbl_update_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql EXTERNAL SECURITY DEFINER;

CREATE TRIGGER rg_koop_4_tbl_update_trigger AFTER UPDATE ON rg_koop_4_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_koop_4_tbl_update_func();

CREATE OR REPLACE FUNCTION rg_koop_4_tbl_delete_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid OLD.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN OLD;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_koop_4_tbl_delete_trigger AFTER DELETE ON rg_koop_4_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_koop_4_tbl_delete_func();

-- DROP TRIGGER rg_koop_5_tbl_insert_trigger ON rg_koop_5_tbl CASCADE;
-- DROP FUNCTION rg_koop_5_tbl_insert_func();
-- DROP TRIGGER rg_koop_5_tbl_delete_trigger ON rg_koop_5_tbl CASCADE;
-- DROP FUNCTION rg_koop_5_tbl_delete_func();

CREATE OR REPLACE FUNCTION rg_koop_5_tbl_insert_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_koop_5_tbl_insert_trigger AFTER INSERT ON rg_koop_5_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_koop_5_tbl_insert_func();

CREATE OR REPLACE FUNCTION rg_koop_5_tbl_update_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql EXTERNAL SECURITY DEFINER;

CREATE TRIGGER rg_koop_5_tbl_update_trigger AFTER UPDATE ON rg_koop_5_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_koop_5_tbl_update_func();

CREATE OR REPLACE FUNCTION rg_koop_5_tbl_delete_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid OLD.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN OLD;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_koop_5_tbl_delete_trigger AFTER DELETE ON rg_koop_5_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_koop_5_tbl_delete_func();

-- DROP TRIGGER rg_koop_bewertungen_tbl_insert_trigger ON rg_koop_bewertungen_tbl CASCADE;
-- DROP FUNCTION rg_koop_bewertungen_tbl_insert_func();
-- DROP TRIGGER rg_koop_bewertungen_tbl_delete_trigger ON rg_koop_bewertungen_tbl CASCADE;
-- DROP FUNCTION rg_koop_bewertungen_tbl_delete_func();

CREATE OR REPLACE FUNCTION rg_koop_bewertungen_tbl_insert_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_koop_bewertungen_tbl_insert_trigger AFTER INSERT ON rg_koop_bewertungen_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_koop_bewertungen_tbl_insert_func();

CREATE OR REPLACE FUNCTION rg_koop_bewertungen_tbl_update_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql EXTERNAL SECURITY DEFINER;

CREATE TRIGGER rg_koop_bewertungen_tbl_update_trigger AFTER UPDATE ON rg_koop_bewertungen_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_koop_bewertungen_tbl_update_func();

CREATE OR REPLACE FUNCTION rg_koop_bewertungen_tbl_delete_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid OLD.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN OLD;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_koop_bewertungen_tbl_delete_trigger AFTER DELETE ON rg_koop_bewertungen_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_koop_bewertungen_tbl_delete_func();

-- rgroups
-- Add create_rg functions WITHOUT DS IS check and exception

CREATE OR REPLACE FUNCTION create_rg_koop_1_tbl(pid integer, nuuid char(36))
RETURNS integer
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    rid integer;
    mid integer;
BEGIN
    mid := pid;

 --   IF NOT isEditorOrStandin(mid) THEN
 --      RAISE EXCEPTION 'DS ID not session_user ID';
 --   END IF;

    INSERT INTO rg_koop_1_tbl (master_id) VALUES (pid);

    SELECT INTO rid currval('rg_koop_1_tbl_id_seq');

    IF nuuid IS NOT NULL THEN
        UPDATE rg_koop_1_tbl
        SET    uuid_id = nuuid
        WHERE  id = rid;
    ELSE
        PERFORM set_uuid('rg_koop_1_tbl', rid);
        
    END IF;

    RETURN rid;
END;
$$;

CREATE OR REPLACE FUNCTION create_rg_koop_2_tbl(pid integer, nuuid char(36))
RETURNS integer
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    rid integer;
    mid integer;
BEGIN
    mid := pid;

   -- IF NOT isEditorOrStandin(mid) THEN
   --     RAISE EXCEPTION 'DS ID not session_user ID';
   -- END IF;

    INSERT INTO rg_koop_2_tbl (master_id) VALUES (pid);

    SELECT INTO rid currval('rg_koop_2_tbl_id_seq');

    IF nuuid IS NOT NULL THEN
        UPDATE rg_koop_2_tbl
        SET    uuid_id = nuuid
        WHERE  id = rid;
    ELSE
        PERFORM set_uuid('rg_koop_2_tbl', rid);
        
    END IF;

    RETURN rid;
END;
$$;

CREATE OR REPLACE FUNCTION create_rg_koop_3_tbl(pid integer, nuuid char(36))
RETURNS integer
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    rid integer;
    mid integer;
BEGIN
    mid := pid;

    --IF NOT isEditorOrStandin(mid) THEN
    --    RAISE EXCEPTION 'DS ID not session_user ID';
    --END IF;

    INSERT INTO rg_koop_3_tbl (master_id) VALUES (pid);

    SELECT INTO rid currval('rg_koop_3_tbl_id_seq');

    IF nuuid IS NOT NULL THEN
        UPDATE rg_koop_3_tbl
        SET    uuid_id = nuuid
        WHERE  id = rid;
    ELSE
        PERFORM set_uuid('rg_koop_3_tbl', rid);
        
    END IF;

    RETURN rid;
END;
$$;


CREATE OR REPLACE FUNCTION create_rg_koop_4_tbl(pid integer, nuuid char(36))
RETURNS integer
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    rid integer;
    mid integer;
BEGIN
    mid := pid;

    --IF NOT isEditorOrStandin(mid) THEN
    --    RAISE EXCEPTION 'DS ID not session_user ID';
    --END IF;

    INSERT INTO rg_koop_4_tbl (master_id) VALUES (pid);

    SELECT INTO rid currval('rg_koop_4_tbl_id_seq');

    IF nuuid IS NOT NULL THEN
        UPDATE rg_koop_4_tbl
        SET    uuid_id = nuuid
        WHERE  id = rid;
    ELSE
        PERFORM set_uuid('rg_koop_4_tbl', rid);
        
    END IF;

    RETURN rid;
END;
$$;

CREATE OR REPLACE FUNCTION create_rg_koop_5_tbl(pid integer, nuuid char(36))
RETURNS integer
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    rid integer;
    mid integer;
BEGIN
    mid := pid;

--    IF NOT isEditorOrStandin(mid) THEN
--        RAISE EXCEPTION 'DS ID not session_user ID';
--    END IF;

    INSERT INTO rg_koop_5_tbl (master_id) VALUES (pid);

    SELECT INTO rid currval('rg_koop_5_tbl_id_seq');

    IF nuuid IS NOT NULL THEN
        UPDATE rg_koop_5_tbl
        SET    uuid_id = nuuid
        WHERE  id = rid;
    ELSE
        PERFORM set_uuid('rg_koop_5_tbl', rid);
        
    END IF;

    RETURN rid;
END;
$$;


CREATE OR REPLACE FUNCTION create_rg_koop_bewertungen_tbl(pid integer, nuuid char(36))
RETURNS integer
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    rid integer;
    mid integer;
BEGIN
    mid := pid;

--    IF NOT isEditorOrStandin(mid) THEN
--        RAISE EXCEPTION 'DS ID not session_user ID';
--    END IF;

    INSERT INTO rg_koop_bewertungen_tbl (master_id) VALUES (pid);

    SELECT INTO rid currval('rg_koop_bewertungen_tbl_id_seq');

    IF nuuid IS NOT NULL THEN
        UPDATE rg_koop_bewertungen_tbl
        SET    uuid_id = nuuid
        WHERE  id = rid;
    ELSE
        PERFORM set_uuid('rg_koop_bewertungen_tbl', rid);
        
    END IF;

    RETURN rid;
END;
$$;

--
-- Convert data of old rg tables into the new tables
--

-- help table for insert rg()
CREATE TABLE tmp_insert_rg_helper (inst INTEGER, type1 INTEGER);

-- 1. öffentliche und freie Jugendhilfe
INSERT INTO tmp_insert_rg_helper (inst, type1) VALUES (0, 1);
INSERT INTO tmp_insert_rg_helper (inst, type1) VALUES (1, 1);
INSERT INTO tmp_insert_rg_helper (inst, type1) VALUES (2, 1);
INSERT INTO tmp_insert_rg_helper (inst, type1) VALUES (3, 1);
INSERT INTO tmp_insert_rg_helper (inst, type1) VALUES (4, 1);
INSERT INTO tmp_insert_rg_helper (inst, type1) VALUES (5, 1);
INSERT INTO tmp_insert_rg_helper (inst, type1) VALUES (6, 1);
INSERT INTO tmp_insert_rg_helper (inst, type1) VALUES (7, 1);
INSERT INTO tmp_insert_rg_helper (inst, type1) VALUES (8, 1);
INSERT INTO tmp_insert_rg_helper (inst, type1) VALUES (9, 1);
INSERT INTO tmp_insert_rg_helper (inst, type1) VALUES (10, 1);
INSERT INTO tmp_insert_rg_helper (inst, type1) VALUES (11, 1);
INSERT INTO tmp_insert_rg_helper (inst, type1) VALUES (13, 1);
INSERT INTO tmp_insert_rg_helper (inst, type1) VALUES (60, 1);

-- 2. Integrationsbezogene Einrichtungen
INSERT INTO tmp_insert_rg_helper (inst, type1) VALUES (14, 2);
INSERT INTO tmp_insert_rg_helper (inst, type1) VALUES (15, 2);
INSERT INTO tmp_insert_rg_helper (inst, type1) VALUES (16, 2);
INSERT INTO tmp_insert_rg_helper (inst, type1) VALUES (17, 2);
INSERT INTO tmp_insert_rg_helper (inst, type1) VALUES (58, 2);
INSERT INTO tmp_insert_rg_helper (inst, type1) VALUES (19, 2);
INSERT INTO tmp_insert_rg_helper (inst, type1) VALUES (25, 2);
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (20, 2);
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (21, 2);
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (22, 2);
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (23, 2);
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (24, 2);
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (26, 2);
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (43, 2);
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (18, 2);
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (27, 2);

-- 3. Schulen
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (28, 3);
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (29, 3);
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (30, 3);
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (57, 3);
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (31, 3);
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (32, 3);
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (33, 3);
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (34, 3);

-- 4. Weitere öffentliche Einrichtungen
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (35, 4);
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (61, 4);
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (36, 4);
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (37, 4);
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (38, 4);
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (39, 4);
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (40, 4);
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (41, 4);
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (42, 4);
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (44, 4);
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (45, 4);

-- 5. Andere Organisationen
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (46, 5);
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (47, 5);
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (63, 5);
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (48, 5);
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (49, 5);
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (50, 5);
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (51, 5);
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (62, 5);
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (52, 5);
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (53, 5);
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (55, 5);
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (56, 5);
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (54, 5);
INSERT INTO tmp_insert_rg_helper (inst,type1) VALUES (64, 5);

-- insert_rg()
CREATE OR REPLACE FUNCTION insert_rg() RETURNS VOID AS $$
DECLARE
  r RECORD;
  r2 RECORD;
  rgid INTEGER;
  rg_count1 INTEGER;
  rg_count2 INTEGER;
  rg_count3 INTEGER;
  uuid TEXT;
BEGIN
  FOR r IN SELECT id, inst, type1 FROM tmp_insert_rg_helper, master_tbl
  LOOP
     rg_count1 := (SELECT COUNT(*) FROM rg_kooperationsbezug_tbl AS koop
                 WHERE r.inst = institution_art
                 AND r.id = koop.master_id);
     rg_count2 := (SELECT COUNT(*) FROM rg_kooperationsbezug_tbl AS koop
                 WHERE r.inst = institution_art AND institution_ist = 1
                 AND r.id = koop.master_id);
     rg_count3 := (SELECT COUNT(*) FROM rg_kooperationsbezug_tbl AS koop
                 WHERE r.inst = institution_art
                 AND institution_ist = 1
                 AND kooperation_schriftlich_festgelegt = 1
                 AND r.id = koop.master_id);
     IF r.type1 = 1 AND rg_count1 > 0 THEN
         uuid = generate_uuidgen();
         rgid = create_rg_koop_1_tbl(r.id, uuid);
         UPDATE rg_koop_1_tbl SET
                rg_koop_1_institution_art = r.inst,
                rg_koop_1_anzahl = rg_count1,
                rg_koop_1_partner = rg_count2,
                rg_koop_1_schriftlich = rg_count3
         WHERE id = rgid;    
     END IF;
     IF r.type1 = 2 AND rg_count1 > 0 THEN
         uuid = generate_uuidgen();
         rgid = create_rg_koop_2_tbl(r.id, uuid);
         UPDATE rg_koop_2_tbl SET
                rg_koop_2_institution_art = r.inst,
                rg_koop_2_anzahl = rg_count1,
                rg_koop_2_partner = rg_count2,
                rg_koop_2_schriftlich = rg_count3
         WHERE id = rgid;    
     END IF;
     IF r.type1 = 3 AND rg_count1 > 0 THEN
         uuid = generate_uuidgen();
         rgid = create_rg_koop_3_tbl(r.id, uuid);
         UPDATE rg_koop_3_tbl SET
                rg_koop_3_institution_art = r.inst,
                rg_koop_3_anzahl = rg_count1,
                rg_koop_3_partner = rg_count2,
                rg_koop_3_schriftlich = rg_count3
         WHERE id = rgid;    
     END IF;
     IF r.type1 = 4 AND rg_count1 > 0 THEN
         uuid = generate_uuidgen();
         rgid = create_rg_koop_4_tbl(r.id, uuid);
         UPDATE rg_koop_4_tbl SET
                rg_koop_4_institution_art = r.inst,
                rg_koop_4_anzahl = rg_count1,
                rg_koop_4_partner = rg_count2,
                rg_koop_4_schriftlich = rg_count3
         WHERE id = rgid;    
     END IF;
     IF r.type1 = 5 AND rg_count1 > 0 THEN
         uuid = generate_uuidgen();
         rgid = create_rg_koop_5_tbl(r.id, uuid);
         UPDATE rg_koop_5_tbl SET
                rg_koop_5_institution_art = r.inst,
                rg_koop_5_anzahl = rg_count1,
                rg_koop_5_partner = rg_count2,
                rg_koop_5_schriftlich = rg_count3
         WHERE id = rgid;    
     END IF;

     FOR r2 IN SELECT * FROM rg_kooperationsbezug_tbl
     WHERE r.inst = institution_art 
     AND master_id = r.id
     LOOP
        uuid = generate_uuidgen();
        rgid = create_rg_koop_bewertungen_tbl(r.id, uuid);

        UPDATE rg_koop_bewertungen_tbl SET
        rg_koop_bewertungen_institution_art = r2.institution_art,
        institution_unterstuetzt_aktiv = r2.institution_unterstuetzt_aktiv,
        jmd_erreicht_andere_durchfuehrung = r2.jmd_erreicht_andere_durchfuehrung,
        jmd_hat_einfluss_teilnehmer = r2.jmd_hat_einfluss_teilnehmer,
        institution_legt_infomaterial = r2.institution_legt_infomaterial,
        institution_zufuehrung_menschen = r2.institution_zufuehrung_menschen,
        besteht_informationsaustausch = r2.besteht_informationsaustausch,
        besteht_regelmaessiger_austausch_fallbezogen = r2.besteht_regelmaessiger_austausch_fallbezogen,
        besteht_regelmaessiger_austausch_nichtfallbezogen = r2.besteht_regelmaessiger_austausch_nichtfallbezogen,
        besteht_abstimmung_integrationsfp = r2.besteht_abstimmung_integrationsfp,
        besteht_planung_veranstaltung = r2.besteht_planung_veranstaltung,
        besteht_gemeinsame_oeffentlichkeitsarbeit = r2.besteht_gemeinsame_oeffentlichkeitsarbeit,
        kontakt_besteht_ueber_gremien = r2.kontakt_besteht_ueber_gremien,
        jmd_nimmt_an_verstaltungen_teil = r2.jmd_nimmt_an_verstaltungen_teil,
        jmd_fuehrt_beratung_durch = r2.jmd_fuehrt_beratung_durch,
        kooperation_schriftlich_festgelegt = r2.kooperation_schriftlich_festgelegt,
        jmd_als_partner_auf_augenhoehe = r2.jmd_als_partner_auf_augenhoehe,
        kontaktform = r2.kontaktform,
        gesamtbewertung = r2.gesamtbewertung,
        nennung_besonderheiten_zusammenarbeit = r2.nennung_besonderheiten_zusammenarbeit,
        nennung_erfahrungen_zusammenarbeit = r2.nennung_erfahrungen_zusammenarbeit
        WHERE id = rgid;    
     END LOOP;
  END LOOP;
END;
$$ LANGUAGE plpgsql;

-- Run the insert_rg func
SET ROLE postgres;
SELECT insert_rg();
SET ROLE :db_adm;

-- Clean up insert_rg
DROP FUNCTION insert_rg();
DROP TABLE tmp_insert_rg_helper;

-- Set rg create and delete functions
CREATE OR REPLACE FUNCTION create_rg_koop_1_tbl(pid integer, nuuid char(36))
RETURNS integer
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    rid integer;
    mid integer;
BEGIN
    mid := pid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    INSERT INTO rg_koop_1_tbl (master_id) VALUES (pid);

    SELECT INTO rid currval('rg_koop_1_tbl_id_seq');

    IF nuuid IS NOT NULL THEN
        UPDATE rg_koop_1_tbl
        SET    uuid_id = nuuid
        WHERE  id = rid;
    ELSE
        PERFORM set_uuid('rg_koop_1_tbl', rid);
        
    END IF;

    RETURN rid;
END;
$$;

CREATE OR REPLACE FUNCTION delete_rg_koop_1_tbl(rid integer)
RETURNS void
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid master_id FROM rg_koop_1_tbl WHERE id = rid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    DELETE FROM rg_koop_1_tbl WHERE id = rid;
END;
$$;

CREATE OR REPLACE FUNCTION create_rg_koop_2_tbl(pid integer, nuuid char(36))
RETURNS integer
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    rid integer;
    mid integer;
BEGIN
    mid := pid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    INSERT INTO rg_koop_2_tbl (master_id) VALUES (pid);

    SELECT INTO rid currval('rg_koop_2_tbl_id_seq');

    IF nuuid IS NOT NULL THEN
        UPDATE rg_koop_2_tbl
        SET    uuid_id = nuuid
        WHERE  id = rid;
    ELSE
        PERFORM set_uuid('rg_koop_2_tbl', rid);
        
    END IF;

    RETURN rid;
END;
$$;

CREATE OR REPLACE FUNCTION delete_rg_koop_2_tbl(rid integer)
RETURNS void
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid master_id FROM rg_koop_2_tbl WHERE id = rid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    DELETE FROM rg_koop_2_tbl WHERE id = rid;
END;
$$;

CREATE OR REPLACE FUNCTION create_rg_koop_3_tbl(pid integer, nuuid char(36))
RETURNS integer
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    rid integer;
    mid integer;
BEGIN
    mid := pid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    INSERT INTO rg_koop_3_tbl (master_id) VALUES (pid);

    SELECT INTO rid currval('rg_koop_3_tbl_id_seq');

    IF nuuid IS NOT NULL THEN
        UPDATE rg_koop_3_tbl
        SET    uuid_id = nuuid
        WHERE  id = rid;
    ELSE
        PERFORM set_uuid('rg_koop_3_tbl', rid);
        
    END IF;

    RETURN rid;
END;
$$;

CREATE OR REPLACE FUNCTION delete_rg_koop_3_tbl(rid integer)
RETURNS void
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid master_id FROM rg_koop_3_tbl WHERE id = rid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    DELETE FROM rg_koop_3_tbl WHERE id = rid;
END;
$$;

CREATE OR REPLACE FUNCTION create_rg_koop_4_tbl(pid integer, nuuid char(36))
RETURNS integer
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    rid integer;
    mid integer;
BEGIN
    mid := pid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    INSERT INTO rg_koop_4_tbl (master_id) VALUES (pid);

    SELECT INTO rid currval('rg_koop_4_tbl_id_seq');

    IF nuuid IS NOT NULL THEN
        UPDATE rg_koop_4_tbl
        SET    uuid_id = nuuid
        WHERE  id = rid;
    ELSE
        PERFORM set_uuid('rg_koop_4_tbl', rid);
        
    END IF;

    RETURN rid;
END;
$$;

CREATE OR REPLACE FUNCTION delete_rg_koop_4_tbl(rid integer)
RETURNS void
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid master_id FROM rg_koop_4_tbl WHERE id = rid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    DELETE FROM rg_koop_4_tbl WHERE id = rid;
END;
$$;

CREATE OR REPLACE FUNCTION create_rg_koop_5_tbl(pid integer, nuuid char(36))
RETURNS integer
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    rid integer;
    mid integer;
BEGIN
    mid := pid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    INSERT INTO rg_koop_5_tbl (master_id) VALUES (pid);

    SELECT INTO rid currval('rg_koop_5_tbl_id_seq');

    IF nuuid IS NOT NULL THEN
        UPDATE rg_koop_5_tbl
        SET    uuid_id = nuuid
        WHERE  id = rid;
    ELSE
        PERFORM set_uuid('rg_koop_5_tbl', rid);
        
    END IF;

    RETURN rid;
END;
$$;

CREATE OR REPLACE FUNCTION delete_rg_koop_5_tbl(rid integer)
RETURNS void
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid master_id FROM rg_koop_5_tbl WHERE id = rid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    DELETE FROM rg_koop_5_tbl WHERE id = rid;
END;
$$;

CREATE OR REPLACE FUNCTION create_rg_koop_bewertungen_tbl(pid integer, nuuid char(36))
RETURNS integer
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    rid integer;
    mid integer;
BEGIN
    mid := pid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    INSERT INTO rg_koop_bewertungen_tbl (master_id) VALUES (pid);

    SELECT INTO rid currval('rg_koop_bewertungen_tbl_id_seq');

    IF nuuid IS NOT NULL THEN
        UPDATE rg_koop_bewertungen_tbl
        SET    uuid_id = nuuid
        WHERE  id = rid;
    ELSE
        PERFORM set_uuid('rg_koop_bewertungen_tbl', rid);
        
    END IF;

    RETURN rid;
END;
$$;

CREATE OR REPLACE FUNCTION delete_rg_koop_bewertungen_tbl(rid integer)
RETURNS void
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid master_id FROM rg_koop_bewertungen_tbl WHERE id = rid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    DELETE FROM rg_koop_bewertungen_tbl WHERE id = rid;
END;
$$;


-- Drop the old stuff (rg_kooperationsbezug_tbl.. + option tables)
DROP TRIGGER rg_kooperationsbezug_tbl_insert_trigger ON rg_kooperationsbezug_tbl CASCADE;
DROP FUNCTION rg_kooperationsbezug_tbl_insert_func();
DROP TRIGGER rg_kooperationsbezug_tbl_delete_trigger ON rg_kooperationsbezug_tbl CASCADE;
DROP FUNCTION rg_kooperationsbezug_tbl_delete_func();
DROP TABLE rg_kooperationsbezug_tbl CASCADE;

DROP TABLE institution_art_tbl CASCADE;
DROP TABLE institution_ist_tbl CASCADE;
DROP TABLE institution_angaben_tbl CASCADE;

-- Enable trigger again.
ALTER TABLE master_tbl ENABLE TRIGGER USER;

COMMIT;





