## -*- coding: utf-8 -*-
<%def name="newstatform(title, legend, years, submiturl, hidden=())">
  
<div class="row">
  <div id="content_ueberschrift" class="col offset-1">
      <h3>${title}</h3>
  </div>
</div>

<div class="formularpage col-8 offset-1">

<form action="${submiturl}" method="POST"
      accept-charset="UTF-8">
    ${h.csrf_token()}
    <h4 class="text-muted">${legend}</h4>
    
    <div class="form-group mb-4">
      <div class="form-row">
         <div class="form-group col-4">
            <label class="text-nowrap" for="name_der_schule">Name der Schule</label>
            <input type="text" class="form-control form-control-sm" name="name_der_schule"
                   id="name_der_schule" maxlength="60"
                   value="Set by render_htmlfill()." />
            <small class="alert-danger errortipp"><form:error name="partner"></small>
         </div>
        <div class="form-group col-2">
            <label class="text-nowrap" for="datum_begin_kooperation">Beginn Kooperation</label>
            <input type="text" class="datefield mpuls-datepicker form-control form-control-sm"
                   name="datum_begin_kooperation"
                   id="datum_begin_kooperation" maxlength="10" onchange="setModification();"
                   value="" />
            <small class="alert-danger errortipp"><form:error name="datum_begin_kooperation"></small>
         </div>
      </div>
      <div class="form-row">           
         <div style="display:none" class="form-group col-2">
            <label class="text-nowrap" for="datum_ende_kooperation">Ende Kooperation</label>
            <input type="text" class="datefield mpuls-datepicker form-control form-control-sm"
                   name="datum_ende_kooperation"
                   id="datum_ende_kooperation" maxlength="10" onchange="setModification();"
                   value="" />
            <small class="alert-danger errortipp"><form:error name="datum_ende_kooperation"></small>
         </div>
      </div>
    </div>
    <div class="form-group">
      <input class="btn btn-primary" type="submit" name="save"
           value="Kooperation anlegen">
    </div>
    % for name in hidden:
    <input type="hidden" name="${name}">
    % endfor
  </form>
</div>
</%def>
