## -*- coding: utf-8 -*-
<%!  import mpulsweb.lib.helper.filters as F %>
<div class="table-responsive">
  <table class="table table-sm summary logbook-table-striped">
    <thead>
      <tr>
        <th> ${_('Date')} </th>
        <th> ${_('Title')} </th>
        <th></th>
        <th></th>
      </tr>
    </thead>
    %for news in c.news.getList():
      <tr class="first-table-row">
        <td scope="col">${h.dd_mm_YYYY(news.date)}</td>
        <td scope="col">${h.literal(news.title)}</td>
        <td scope="col"></td>
        <td scope="col" class="icon-td">
        % if h.hasRole(['admin']):
          
        % else:
          <a role="button" title="${_('Mark this entry as read')}"
             href="${h.url(controller='news', action='hide', id=news.id)}">
            <svg class="svg-icon" aria-labelledby="title" role="img">
              <title id="title">${_('Mark this entry as read')}</title>
              <use xlink:href="#check" />
            </svg>
          </a>
         % endif
        </td>
      </tr>
    <tr class="second-table-row">
      <td colspan="4" class="description">
        <p>
          ${h.literal(news.text)}
        </p>
      </td>
    </tr>
    %endfor
  </table>
</div>
