<%inherit file="/appointments/remindlist_body.mako" />
<%def name="showAppointmentActions(appointment)">
  <a href="${h.url(controller='case', action='select',
                       id=appointment.case_id, confirmed=0)}">
    <img src    = "${h.url('/images/icons/open_active.png')}"
         alt    = "${_('Show')}"
         title  = "${_('Show')}">
  </a>
</%def>

<%def name="showKeepActiveActions(appointment)">
  <a title="${_('New case document')}" href="${h.url(controller='case', action='new')}">
    <img src    = "${h.url('/images/icons/new.png')}"
         alt    = "${_('New case document')}"
         title  = "${_('New case document')}"></a>
    <svg class="svg-icon-disabled" aria-labelledby="title" role="img">
      <title id="title">${_('New case document')}</title>
      <use xlink:href="#plus-circle-solid" />
    </svg>
</%def>
