<%inherit file="/appointments/overview_body.mako" />
<%def name="showAppointmentActions(appointment, show_set_done=False)">
  % if h.hasRole(['cm']) and session.get('case').getState().getState() == 1:
    <a role="button"
       href="${h.url(controller='caseappointment', action='delete',
                        id=appointment.id, confirmed=0)}">
      <svg class="svg-icon svg-warning">
        <title>${_('Delete')}</title>
        <use xlink:href="#delete" />
      </svg>
    </a>
  % endif
</%def>

<%def name="showAppointmentURL(appointment)">
  "${h.url(controller='caseappointment', action='show', id=appointment.id, confirmed='1')}"
</%def>

