## -*- coding: utf-8 -*-
<%inherit file="/casemanagement/main.mako" />
<%!  import mpulsweb.lib.helper.filters as F %>
<%def name="buildNavipath()">
  ${parent.buildNavipath()}
  <li><a href="${h.url(controller='case', action='select', id=session.get('case').id, confirmed=1)}">${_('Selected case documents')}</a></li>
  <li><a href="${h.url(controller='case', action='logbook', id=session.get('case').id)}">${_('Logbook')}</a></li>
  <li><a href="#"></a>${_('Entries')}</a></li>

</%def>

<div class="row">
  <div class="col-8 btn-print d-print-none">
        <a class="btn btn-primary btn-sm" role="button" href="javascript: window.print()">Drucken</a>
        ## A new case has no id - show Back button only in this situation
        % if not session.get('case').id:
        <a class="btn btn-outline-primary btn-sm" role="button" type="submit"
           href="${h.url('/case/new2')}">Zurück zu „Fallakte anlegen“
        </a>
        % else:
        <a class="btn btn-outline-primary btn-sm" role="button" type="submit"
           href="javascript: window.close()">Fenster schließen</a>
        % endif
  </div>
</div>

<div class="row print-margin">
  <div id="content_ueberschrift" class="col-auto">
      <h3>Tagebuch - ${c.case.last_name}, ${c.case.first_name}</h3>
  </div>
    <div class="border-sidebar rounded p-4 ml-auto">${self.buildInfofield1()}</div>
</div>

% for entry in c.logbook.getEntries():
<div class="table-responsive">
    <table class="table table-sm table-borderless summary">
        <tbody>
            <tr>
                <td>${_('Date')}</td>
                <td>${entry.getDate()} ${entry.getTime()}</td>
            </tr>
            <tr>
                <td>${_('Editor')}</td>
                <td>${entry.getEditor()}</td>
            </tr>
            <tr>
                <td>${_('Type')}</td>
                <td>${entry.getKindsAsText()}</td>
            </tr>
            <tr>
                <td>${_('Duration in minutes')}</td>
                <td>${entry.getDuration('-/-')}</td>
            </tr>
            <tr>
                <td>${_('Note')}</td>
                <td>${entry.notiz|n,F.NA}</td>
            </tr>
        </tbody>
    </table>
  </div>
  <hr>
% endfor
