## -*- coding: utf-8 -*-
<%inherit file="/casemanagement/main.mako" />
<%def name="buildNavipath()">
  ${parent.buildNavipath()}
  <li>
    <a href="${h.url(controller='case', action='select', id=session.get('case').id, confirmed=1)}">
      ${_('Selected case documents')}
    </a>
  </li>
  <li>
    <a href="${h.url(controller='logbook', action='index', id=session.get('case').id)}">
      ${_('Logbook')}
    </a>
  </li>
  <li>
    <a href="${h.url(controller='logbook', action='show', id=c.entry.id)}">
      ${_('Logbook entry')}
    </a>
  </li>
  <li>
    <a href="#"></a>${_('Rename attachment')}

  </li>
</%def>

<%def name="title()">
    ${h.get_app_title()} - ${_('Rename attachment')}
</%def>

<div>
<div id="content_header">
  <div class="row">
        <div id="content_ueberschrift" class="col-auto offset-1">
           <h3>${_('Rename attachment')}</h3>
        </div>
        <div class="col modusfield">
          <a title="${_('Back to: View entry')}" href="${h.url(controller='logbook', action='show', id=c.logbook_id)}">
            <svg class="svg-icon" aria-labelledby="title" role="img">
              <title id="title">${_('Back to: View entry')}</title>
              <use xlink:href="#arrow-circle-left" />
            </svg>
          </a>
        </div>
  </div>
</div>
<div class="formularpage col-xl-9 offset-1">
${c.rendered_form.rendered_errors}

${c.rendered_form.rendered_form}
</div>
</div>
