## -*- coding: utf-8 -*-
<%inherit file="../main.mako" />
<%def name="buildNavipath()">
  ${parent.buildNavipath()}
  <li>
    <a href="${h.url(controller='settings', action='index')}">${_('Administration')}</a>
  </li>
  <li>
    <a href="${h.url(controller='settings', action='show')}">${_('Show settings')}</a>
  </li>
  <li>
    <a href="${h.url(controller='settings', action='edit')}">${_('Edit settings')}</a>
  </li>
</%def>

<%def name="title()">
    ${h.get_app_title()} - ${_('Edit settings')}
</%def>

<div class="row">
  <div class="col-auto offset-1" id="content_ueberschrift">
    <h3>${_('Edit settings')}</h3>
  </div>
  <div class="col modusfield">
    <a title="${_('Back to: institution settings')}" href="${h.url(controller='settings', action='show')}">
      <svg class="svg-icon" aria-labelledby="title" role="img">
        <title id="title">${_('Back to: institution settings')}</title>
        <use xlink:href="#arrow-circle-left" />
      </svg>
    </a>
  </div>
</div>
<div class="formularpage col-xl-9 offset-1">
  <p class="info-text">${_('Edit institution settings.')}</p>


  ${c.rendered_form.rendered_errors}
  ${c.rendered_form.rendered_form}
</div>
