## -*- coding: utf-8 -*-
<%inherit file="../auth/main.mako" />
<div class="row">
  <div class="col offset-1" id="content_ueberschrift">
    <h3>${_('Change password needed')}</h3>
  </div>
</div>

<div class="formularpage col-xl-9 offset-1">
  ${self.buildFormErrors()}
  <p>${_('You have to set a new password. This can have following reasons:')}<p>
  <ul>
    <li>${_('You login for the first time with initial password on the system.')}</li>
    <li>${_('You used the same password for a long time. So it has become invalid.')}</li>
    <li>${_('The password has been reset by the administration.')}</li>
  </ul>
  <p>${_('Please insert the new password.')}</p>
  <p>${_('The new password must contain of 12 letter at least and must contain 2 non-character at least. ')}</p>
  <form action="${h.url(controller='usersettings', action='changePasswordOnLoginAction')}" method="POST" autocomplete="off">
    ${ h.csrf_token() }
  	<h5>${_('Information about login')}</h5>
  	<div class="form-row">
            % if c.form_errors.get('passwd'):
              <div class="col">
  	    <label for="passwd" class="error_font">${_('Enter new password')}</label><br>
              <input type="password" class="form-control is-invalid" id="passwd" name="passwd">
              </div>
            % else: 
              <div class="col">  
              <label for="passwd">${_('Enter new password')}</label><br>
              <input type="password" class="form-control" id="passwd" name="passwd">
              </div>
            % endif
            % if c.form_errors.get('passwd2'):
              <div class="col">  
  	    <label for="passwd2" class="error_font">${_('Repeat pasword')}</label><br>
              <input type="password" class="form-control is-invalid" id="passwd2" name="passwd2">
              </div>
            % else: 
              <div class="col">  
  	    <label for="passwd2">${_('Repeat pasword')}</label><br>
              <input type="password" class="form-control" id="passwd2" name="passwd2">
              </div>
            % endif
  	</div>
          <div class="form-row"> 
            <div class="col">
  	    <input class="btn btn-primary" type="submit" value="${_('Save')}">
            </div>
          </div>
  </form>
</div>
