## -*- coding: utf-8 -*-
<%inherit file="../base.mako" />

<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <img src="${h.url('/images/logos/logo_ka_75.png')}"
                     alt="${_('Logo institution')}" border="0">
            <div class="card">
                <div class="card-header">
                </div>
                <div class="card-body">
                    ${next.body()}
                    <p>${_('BMF-phrase %s') % h.get_app_title()}</p>
                     <a target="_blank" href="http://www.bmfsfj.de">
                      <img src="${h.url('/images/logos/BMFSFJ_C_M_web.jpg')}"
                        alt="${_('Logo Federal Ministry for Family, Senior Citizens, Women and youth')}" border="0">
                    </a>
                     <a target="_blank" href="http://www.jugend-staerken.de">
                      <img src="${h.url('/images/logos/jugend-staerken.jpg')}"
                        alt="${_('Logo program To encourage the youth')}" border="0">
                    </a>
                     <a target="_blank" href="http://www.jugendmigrationsdienste.de">
                      <img src="${h.url('/images/logos/logo_ka_75.png')}"
                        alt="${_('Logo Migration Services for Youth')}" border="0">
                    </a>
                </div>
            </div>
        </div>
    </div>
</div>

<%def name="buildFormErrors()">
    <%
      # Please fill this dictionary in the templates if you want to substitute
      # the formular identifier
      formular_labels = {'passwd': _('Enter new password'),
                          'passwd2': _('Repeat pasword')
                          }
    %>
  % if len(c.form_errors) > 0:
  <div class="alert alert-danger" role="alert">
    <a name="error_list"><h3 class="card-subtitle">${_('Formular input error')}</h3></a>
    <ul class="list-group">
      % for key, value in c.form_errors.iteritems():
        <li class="list-group-item">${_(formular_labels.get(key, '%s' % key))}: ${value}</li>
      % endfor
    </ul>
  </div>
  % endif
</%def>
