<%!  import mpulsweb.lib.helper.filters as F %>

<div class="row">
  <div class="col-xl offset-1">
    <legend>
      <div class="text-nowrap">
        <label>${_('Information about personal')}</label>
      </div>
    </legend>
    <div class="table-responsive">
      <table class="table table-sm table-borderless summary">
       <tr>
        <td>${_('Forename')}</td>
        <td>${c.uo.first_name | F.NA}</td>
      </tr>
      <tr>
        <td>${_('Name')}</td>
        <td>${c.uo.last_name | F.NA}</td>
      </tr>
      <tr>
        <td>${_('Phone')}</td>
        <td>${c.uo.telephone | F.NA}</td>
      </tr>
      <tr>
        <td>${_('Institution')}</td>
        <td>${c.uo.branchoffice | F.NA}</td>
      </tr>
      % if g.mpuls_config.is_enabled('case-module', 'organisation'):
      <tr>
        <td>${_('Replace')}</td>
        <td>${c.vuo.name | F.NA}</td>
      </tr>
      % endif
      % if g.mpuls_config.is_enabled('module', 'agency-overview'):
       <tr>
        <td>${_('Visibility')}</td>
        <td>${", ".join(agency.name for agency in c.agency_list if agency.id in
        c.uo.linked_fkz)}</td>
      </tr>
      % endif
     </table>
    </div>
  </div>
</div>

<div class="row">
  <div class="col-xl offset-1">
    <legend>${_('Login settings')}</legend>
    <div class="table-responsive">
      <table class="table table-sm table-borderless summary">
       <tr>
        <td class="col-md-2">${_('Login')}</td>
        <td>${c.uo.getLogin()}</td>
      </tr>
      <tr>
        <td>${_('Role')}</td>
        <td>${c.uo.getRole()}</td>
      </tr>
      % if h.hasRole(['admin']):
      <tr>
        <td>${_('Activated')}</td>
        <td>
          % if c.uo.isActivated():
            ${_('Yes')}
          % else:
            ${_('No')}
          % endif
        </td>
      </tr>
      <tr>
        <td>${_('Ask for new password at login')}</td>
        <td>
          % if c.uo.needsNewPass():
            ${_('Yes')}
          % else:
            ${_('No')}
          % endif
        </td>
      </tr>
      % endif
     </table>
    </div>
  </div>
</div>
