#!/bin/bash

NEWSTITLE=
NEWSBODY=
NEWSTYPE=0 #default: Systemnachricht
NEWSDATE=`date +"%Y-%m-%d"`
PORT=5432
KALIST="KA_list"

while getopts t:n:d:p:a:l:d: o
do
        case ${o} in
        t)      NEWSTITLE=${OPTARG};;
        n)      NEWSBODY=`cat ${OPTARG}`;;
        a)      NEWSTYPE=${OPTARG};;
        d)      NEWSDATE=${OPTARG};;
        p)      PORT=${OPTARG};;
        l)      KALIST=${OPTARG};;
        [?])    echo >&2 "Usage: ${0} -t title -n newsbodyfile [-p port] [-a newstype] [-d date] [-l kalist]"
                exit 1;;

        esac
done

# Check all the importaint stuff is not empty:
if ! [ "$NEWSDATE" -a "$NEWSDATE" -a "$NEWSBODY" ] ; then
    echo "$NEWSDATE -a $NEWSDATE -a $NEWSBODY"
    echo >&2 "date title and body may not be empty!"
    exit 23
fi

#Dumpen und Sichern
for FKZ in `cat ${KALIST}`
do
    echo "Inserting to ka_${FKZ}_db";
    psql -p ${PORT} ka_${FKZ}_db -c "INSERT INTO ka_nachrichten_tbl (datum, art, titel, nachricht) VALUES ('${NEWSDATE}', ${NEWSTYPE}, '${NEWSTITLE}', '${NEWSBODY}')";
done;
exit 0;
